<?php
# 09

function nacti_vstup($soubor, &$takt)
// vrati pole not a pomlk ze vstupniho souboru $soubor, $takt naplni hodnotou taktu
{
	$file = file_get_contents($soubor);
	
	$vals = array();
	
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $file, $vals);
	
	if (($vals[0]['tag'] != 'skladba') && ($vals[count($vals-1)]['tag'] != 'skladba'))
	{
		exit('Chyba ve vstupním souboru');
	}
	
	switch ($vals[0]['attributes']['takt'])
	{
		case '3/4': $takt = 3; break;
		case '4/4': $takt = 4; break;
		case '5/4': $takt = 5; break;
		default: exit('Neznámý takt.');
	}
	
	$skladba = array();
	for ($i=1; $i<count($vals)-1; $i++)
	{
		if ($vals[$i]['tag'] != 'nota' && $vals[$i]['tag'] != 'pomlka')
			exit('Chyba vstupu - nesprávná značka "' . $vals[$i]['tag'] . '"');
		
		$skladba[] = array(
			'typ'	=> $vals[$i]['tag'],
			'delka'	=> $vals[$i]['attributes']['delka'],
			'vyska'	=> ($vals[$i]['tag'] == 'nota' ?
				vyska_noty($vals[$i]['attributes']['vyska']) : null)
			);
	}
	
	return $skladba;
}

function vyska_noty($nota)
// vrati ciselnou vysku noty $nota
{
	$noty = array(
		'C', 'Cis', 'D', 'Dis', 'E', 'F', 'Fis', 'G', 'Gis', 'A', 'Ais', 'H',
		'c', 'cis', 'd', 'dis', 'e', 'f', 'fis', 'g', 'gis', 'a', 'ais', 'h'
		);
	$index = array_search($nota, $noty);
	if ($index === false) exit('Neznámá nota: "' . $nota . '"');
	return $index;
}

function obrazek_znaku($znak)
// vrati jmeno obrazku pro dany $znak
{
	// urcit delku
	switch ($znak['delka'])
	{
	case 0.5: $d = '0'; break;
	case 1: $d = '1'; break;
	case 2: $d = '2'; break;
	case 4: $d = '4'; break;
	default: return '';
	}
	
	// osetrit pomlky
	if ($znak['typ'] == 'pomlka')
	{
		return "pomlka_$d.png";
	}
	
	// noty
	// nahoru/dolu
	if ($znak['delka'] != 4)
		$d = ($znak['vyska'] < 12 ? 'nahoru_' : 'dolu_') . $d;
	
	$zvysene = array(1,3,6,8,10,13,15,18,20,22);
	$zvysena = in_array($znak['vyska'], $zvysene);
	
	if ($zvysena)
		return "nota_krizek_$d.png";
	else
		return "nota_$d.png";
}

function obrazek_umisteni($znak)
// vrati relativni umisteni $znaku v pixelech
{
	// osetrit pomlky - vzdy umisteny stejne
	if ($znak['typ'] == 'pomlka')
	{
		switch ($znak['delka'])
		{
		case 0.5: return 19;
		case 1:   return 15;
		case 2:   return 21;
		case 4:   return 18;
		default: return 0;
		}
	}
	
	$pozice = array(
		0 =>  6,  1  => 6,  2  => 9,  3  => 9,  4  => 12, 5  => 15, 6  => 15,
		7 =>  19, 8  => 19, 9  => 22, 10 => 22, 11 => 25, 12 => 28, 13 => 28,
		14 => 31, 15 => 31, 16 => 34, 17 => 37, 18 => 37, 19 => 40, 20 => 40,
		21 => 43, 22 => 43, 23 => 46
		);
	
	$umisteni = 28 - $pozice[$znak['vyska']];
	
	// nozicka nahoru/dolu
	if ($znak['vyska'] >= 12)
		$umisteni += 17;
	elseif ($znak['delka'] == 4)
		$umisteni += 17;
	
	return $umisteni;
}

?>
